<script>
  import { createEventDispatcher } from 'svelte';
  import { Button, Icon, ListItem, TextField } from 'svelte-materialify';
  import Checkbox from './Checkbox.svelte';

  export let title;
  export let done;

  const dispatch = createEventDispatcher();
  let editMode = false;

  const turnEditMode = () => editMode = true;
  const turnReadMode = () => editMode = false;
  const saveChanges = () => {
    dispatch('rename', title);
    editMode = false;
  }
  const onChange = ({ target }) => {
    title = target.value;
    saveChanges();
  };
</script>

<ListItem>
  <span slot="prepend">
    <Checkbox value={done} on:change={() => dispatch('toggle')} />
  </span>
  {#if editMode}
    <TextField dense outlined bind:value={title} on:change={onChange} />
  {:else}
    <span on:dblclick={turnEditMode}>{title}</span>
  {/if}
  <span slot="append">
    {#if editMode}
      <Button icon class="ma-0" on:click={saveChanges}>
        <Icon class="mdi mdi-check" />
      </Button>
      <Button icon class="ma-0" on:click={turnReadMode}>
        <Icon class="mdi mdi-close" />
      </Button>
    {:else}
      <Button icon class="ma-0" on:click={turnEditMode}>
        <Icon class="mdi mdi-pencil" />
      </Button>
      <Button icon class="ma-0" on:click={() => dispatch('delete')}>
        <Icon class="mdi mdi-trash-can-outline" />
      </Button>
    {/if}
  </span>
</ListItem>
